
///////////////////////////////////////////////////////////////////////////
// This program is free software: you can redistribute it and/or modify  //
// it under the terms of the version 3 of the GNU General Public License //
// as published by the Free Software Foundation.                         //
//                                                                       //
// This program is distributed in the hope that it will be useful, but   //
// WITHOUT ANY WARRANTY; without even the implied warranty of            //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      //
// General Public License for more details.                              //
//                                                                       //
// You should have received a copy of the GNU General Public License     //
// along with this program. If not, see <http://www.gnu.org/licenses/>.  //
//                                                                       //
// Written by Francois Fleuret                                           //
// (C) Idiap Research Institute                                          //
//                                                                       //
// Contact <francois.fleuret@idiap.ch> for comments & bug reports        //
///////////////////////////////////////////////////////////////////////////

#include "interval.h"

void Interval::set(scalar_t x) {
  min = x;
  max = x;
}

void Interval::set(scalar_t a, scalar_t b) {
  min = a;
  max = b;
}

void Interval::set(Interval *i) {
  min = i->min;
  max = i->max;
}

void Interval::set_subinterval(Interval *i, int k, int nb) {
  min = i->min + ((i->max - i->min) * scalar_t(k))/scalar_t(nb);
  max = i->min + ((i->max - i->min) * scalar_t(k + 1))/scalar_t(nb);
}

void Interval::swallow(Interval *i) {
  min = ::min(min, i->min);
  max = ::max(max, i->max);
}

ostream &operator << (ostream &out, const Interval &i) {
  return out << "[" << i.min << ", " << i.max << "]";
}
