
///////////////////////////////////////////////////////////////////////////
// This program is free software: you can redistribute it and/or modify  //
// it under the terms of the version 3 of the GNU General Public License //
// as published by the Free Software Foundation.                         //
//                                                                       //
// This program is distributed in the hope that it will be useful, but   //
// WITHOUT ANY WARRANTY; without even the implied warranty of            //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      //
// General Public License for more details.                              //
//                                                                       //
// You should have received a copy of the GNU General Public License     //
// along with this program. If not, see <http://www.gnu.org/licenses/>.  //
//                                                                       //
// Written by Francois Fleuret                                           //
// (C) Idiap Research Institute                                          //
//                                                                       //
// Contact <francois.fleuret@idiap.ch> for comments & bug reports        //
///////////////////////////////////////////////////////////////////////////

#include "storable.h"

#include <fstream>
#include <stdlib.h>

Storable::~Storable() { }

void Storable::read(const char *name) {
  ifstream in(name);
  if(in.fail()) {
    cerr << "Can not open " << name << " for reading." << endl;
    exit(1);
  }
  read(&in);
}

void Storable::write(const char *name) {
  ofstream out(name);
  if(out.fail()) {
    cerr << "Can not open " << name << " for writing." << endl;
    exit(1);
  }
  write(&out);
}
